function [Jx, flag, new_data] = cvodes_vdv_J(t, y, fy)
%% Provides Jacobian of RHS for cvodes_vdv

global ud;

Jx(1,1) = - ud.k10*exp(-ud.E1/(y(3)+273.15))...
    - 2*ud.k20*exp(-ud.E2/(y(3)+273.15))*y(1)...
    - ud.u1;
Jx(1,2) =   0;
Jx(1,3) = - ud.k10*exp(-ud.E1/(y(3)+273.15))*(ud.E1/(y(3)+273.15)^2)*y(1)...
    - ud.k20*exp(-ud.E2/(y(3)+273.15))*(ud.E2/(y(3)+273.15)^2)*y(1)^2;
Jx(1,4) =   0;



Jx(2,1) =   ud.k10*exp(-ud.E1/(y(3)+273.15));
Jx(2,2) = - ud.k10*exp(-ud.E1/(y(3)+273.15)) - ud.u1;
Jx(2,3) =   ud.k10*exp(-ud.E1/(y(3)+273.15))*(ud.E1/(y(3)+273.15)^2)*(y(1) - y(2));
Jx(2,4) =   0;

Jx(3,1) = - ud.delta0*(ud.k10*exp(-ud.E1/(y(3)+273.15))*ud.DHab...
    + 2*ud.k20*exp(-ud.E2/(y(3)+273.15))*y(1)*ud.DHad);
Jx(3,2) = - ud.delta0*ud.k10*exp(-ud.E1/(y(3)+273.15))*ud.DHbc;
Jx(3,3) = - ud.delta0*(ud.k10*exp(-ud.E1/(y(3)+273.15))...
    *(ud.E1/(y(3)+273.15)^2)*(y(1)*ud.DHab + y(2)*ud.DHbc)...
    + ud.k20*exp(-ud.E2/(y(3)+273.15))...
    *(ud.E2/(y(3)+273.15)^2)*y(1)^2*ud.DHad) - ud.alpha0 - ud.u1;
Jx(3,4) =   ud.alpha0;

Jx(4,1) =   0;
Jx(4,2) =   0;
Jx(4,3) =   ud.beta0;
Jx(4,4) =   -ud.beta0;


flag = 0;
new_data = [];

end
