function [yd, flag, new_data] = cvodes_vdv_f(t, y)
%% Provides RHS function for of nonlinear ODE

global ud;

yd(1) = - ud.k10*exp(-ud.E1/(y(3)+273.15))*y(1)...
    - ud.k20*exp(-ud.E2/(y(3)+273.15))*y(1)^2 ...
    + (ud.cin - y(1))*ud.u1;

yd(2) =   ud.k10*exp(-ud.E1/(y(3)+273.15))*(y(1)-y(2))...
    - y(2)*ud.u1;

yd(3) = - ud.delta0*(ud.k10*exp(-ud.E1/(y(3)+273.15))*(y(1)*ud.DHab...
    + y(2)*ud.DHbc) + ud.k20*exp(-ud.E2/(y(3)+273.15))*y(1)^2*ud.DHad)...
    + ud.alpha0*(y(4) - y(3))...
    + (ud.Tin - y(3))*ud.u1;

yd(4) = ud.beta0*(y(3) - y(4)) + ud.gamma0*ud.u2;

flag = 0;
new_data = [];

end