function [A, flag] = vdv_J(t, x, fx)
%% Provides Jacobian of RHS

global d;

A = zeros(d.Nx);

ca = x(1);
cb = x(2);
T  = x(3);
Tc = x(4);

A(1,1) = -k1(T) - 2*k2(T)*ca - d.u(1);
A(1,2) = 0;
A(1,3) = -k1(T)*d.E1/(T+273.15)^2*ca - k2(T)*d.E2/(T+273.15)^2*ca^2;
A(1,4) = 0;

A(2,1) = k1(T);
A(2,2) = -k1(T) - d.u(1);
A(2,3) = k1(T)*d.E1/(T+273.15)^2*(ca-cb);
A(2,4) = 0;

A(3,1) = -d.delta0*(k1(T)*d.DHab + 2*k2(T)*ca*d.DHad);
A(3,2) = -d.delta0*k1(T)*d.DHbc;
A(3,3) = -d.delta0*(k1(T)*d.E1/(T+273.15)^2*(ca*d.DHab + cb*d.DHbc) + ...
         k2(T)*d.E2/(T+273.15)^2*ca^2*d.DHad) - d.alpha0 - d.u(1);
A(3,4) = d.alpha0;

A(4,1) = 0;
A(4,2) = 0;
A(4,3) = d.beta0;
A(4,4) = -d.beta0;

flag = 0;
end

function k1 = k1(T)
global d
k1 = d.k10*exp(-d.E1/(T+273.15));
end

function k2 = k2(T)
global d
k2 = d.k20*exp(-d.E2/(T+273.15));
end

function h = h(ca,cb,T)
global d
-d.delta0*(k1(T)*(ca*d.DHab + cb*d.DHbc) + k2(T)*ca^2*d.DHad);
end