function [xd, flag] = vdv_f(t, x)
%% Provides RHS function of nonlinear ODE

global d;

ca = x(1);
cb = x(2);
T  = x(3);
Tc = x(4);

xd(1) = -k1(T)*ca - k2(T)*ca^2 + (d.cin - ca)*d.u(1);
xd(2) = k1(T)*(ca - cb) - cb*d.u(1);
xd(3) = h(ca,cb,T) + d.alpha0*(Tc - T) + (d.Tin - T)*d.u(1);
xd(4) = d.beta0*(T - Tc) + d.gamma0*d.u(2);

flag = 0;

end

function k1 = k1(T)
global d
k1 = d.k10*exp(-d.E1/(T+273.15));
end

function k2 = k2(T)
global d
k2 = d.k20*exp(-d.E2/(T+273.15));
end

function h = h(ca,cb,T)
global d
h = -d.delta0*(k1(T)*(ca*d.DHab + cb*d.DHbc) + k2(T)*ca^2*d.DHad);
end