function [qbd,flag] = vdv_qB(t,x,lambda)
%% Provides RHS of adjoint quadrature equations

global d

ca = x(1);
cb = x(2);
T  = x(3);
Tc = x(4);

z = d.C*x + d.D*d.u;
B = zeros(d.Nx,d.Nu);

B(1,1) = d.cin - ca;
B(1,2) = 0;

B(2,1) = - cb;
B(2,2) = 0;

B(3,1) = d.Tin - T;
B(3,2) = 0;

B(4,1) = 0;
B(4,2) = d.gamma0;

qbd = - (d.D'*(d.Q*(z-d.zr) + d.penalty_z(z)) + d.R*(d.u-d.ur) + B'*lambda);

flag = 0;

end